package com.jdbernard.wdiwtlt.cli

public class ScrollText {

    public String text = ""
    public int maxWidth

    private int scrollIdx

    public void setMaxWidth(int max) {
        this.maxWidth = Math.max(max, 1) }

    public void setText(String t) {
        this.text = t
        this.scrollIdx = Math.max(0, text.size() - 10) }

    public String getNextScroll() {
        if (text.size() < maxWidth) return text
        else {
            scrollIdx = (scrollIdx + 1) % text.size()
            int endIdx = Math.min(scrollIdx + maxWidth, text.size())
            int wrapIdx = (scrollIdx + maxWidth) % text.size()

            // don't need to wrap past the end
            if (wrapIdx == endIdx) return text[scrollIdx..<endIdx]
            return new StringBuilder()
                .append(text[scrollIdx..<endIdx])
                .append(" ").append(text[0..<wrapIdx]) } }

    public String toString() { return getNextScroll() }
}
